﻿using DbProfiler.DatabaseAccess.SchemaExtraction;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using DbProfiler.DatabaseAccess;
using System.Xml;

namespace DbProfiler.DatabaseAccess.Tests
{
    
    
    /// <summary>
    ///This is a test class for SchemaExtractorFactoryTest and is intended
    ///to contain all SchemaExtractorFactoryTest Unit Tests
    ///</summary>
    [TestClass()]
    public class SchemaExtractorFactoryTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for GetSchemaExtractor
        ///</summary>
        [TestMethod()]
        public void GetSchemaExtractorTest()
        {
            Database db = new Database();
            db.Name = "AdventureWorks";
            db.DatabaseType = DatabaseType.MsftSqlServer2005;
            db.ConnectionString = "Provider=SQLOLEDB;server=localhost;database=AdventureWorks;Integrated Security=SSPI;";
                                    
            ISchemaExtractor schemaExctractor = SchemaExtractorFactory.GetSchemaExtractor(db);
            XmlDocument xdoc = schemaExctractor.ReadSchema();

            System.Diagnostics.Debug.Write(xdoc.OuterXml);

            Assert.IsTrue(schemaExctractor is SchemaExtraction.MsftSqlSchemaExtractor);
        }
    }
}
